import ddf.minim.*;

Minim minim;
AudioPlayer music;
AudioPlayer laser;

// processing game
int ctext = 0;

int keyUp = 0;
int keyDown = 0;
int keyLeft = 0;
int keyRight = 0;
int keyFire = 0;
int player_base = 270;
int gameover = 0;
int score = 0;
float jump_height = 260;
float player_x=0;
float player_y=player_base;
float player_speed=1.2;
float player_animspeed = 0.13;
float player_jump=0;
int player_animframe = 0;
int player_walking = 0;
int player_jumping = 0; 
float player_anim = 0; 
int texttime = 0;

int soundframes=1;

PImage player_w1;
PImage player_w2;
PImage player_w3;
PImage player_w4;
PImage player_w5;
PImage player_w6;
PImage player_stand;

int enemy_count_current = 0;
int enemy_count = 50;
int enemy_size = 64;
Enemy[] enemies;

int bullet_count = 15;
int bullet_size = 15;
float bullet_speed = 5;

Bullet[] bullets;

PFont font;

String[] texts;

void setup() {
  size(640,320);
  frameRate(60);
  player_w1 = loadImage("p1.png");
  player_w2 = loadImage("p2.png");
  player_w3 = loadImage("p3.png");
  player_w4 = loadImage("p4.png");
  player_w5 = loadImage("p5.png");
  player_w6 = loadImage("p6.png");
  player_stand = loadImage("p_stand.png");
  enemies = new Enemy[enemy_count];
  spawnEnemies(5);
  
  bullets = new Bullet[bullet_count];
  for (int i = 0;i<bullet_count;i++) {
    bullets[i] = new Bullet(0.0,0.0,false);
  }
  
  font = loadFont("font.vlw");
  textFont(font, 32);
  
  minim = new Minim(this);
  music = minim.loadFile("loop.mp3", 1024);
  laser = minim.loadFile("laser.wav", 1024);
  music.loop();
  
  texts = new String[30];
  
  texts[0] = "trilobit / escapism";
  texts[1] = "Why is this here?";
  texts[2] = "...forgot myself there";
  texts[3] = "hat's off? now?";
  texts[4] = "what is this melancholy";
  texts[5] = "supportive? me?";
  texts[6] = "do it, just do it.";
  texts[7] = "quite right you are.";
  texts[8] = "and when is that?";
  texts[9] = "which way did it go?";
  texts[10] = "don't make me laugh!";
  texts[11] = "i have no idea.";
  texts[12] = "a lung disease.";
  texts[13] = "destroy the supports.";
  texts[14] = "why is that? really!";
  texts[15] = "which way again?";
  texts[16] = "structs? metal structs?";
  texts[17] = "gas pipe is not me.";
  texts[18] = "a red cardigan.";
  texts[19] = "towels were brought.";
  texts[20] = "sad but sightful.";
  texts[21] = "endless voyage?";
  texts[22] = "who is at the door?";
  texts[23] = "it's breakfast time!";
  texts[24] = "teleportation is a dream.";
  texts[25] = "buy my book! buy my book!";
  texts[26] = "i'm so happy i might cry.";
  texts[27] = "no!";
  texts[28] = "be a little supportive.";
  texts[29] = "it's a pipe dream.";  

}

void keyReleased() {
  if (key == 'w') keyUp = 2;
  if (key == 's') keyDown = 2;
  if (key == 'a') keyLeft = 2;
  if (key == 'd') keyRight = 2;
  if (key == ' ') keyFire = 2;
}

void keyPressed() {
  if (key == 'w') keyUp = 1;
  if (key == 's') keyDown = 1;
  if (key == 'a') keyLeft = 1;
  if (key == 'd') keyRight = 1;
  if (key == ' ') keyFire = 1;
}

void drawBG() {
  background(123,138,153);
  noStroke();
  fill(64);
  rect(0,0,width,6);
  fill(86);
  rect(0,height-8,width,height);
}

void spawnEnemies(int count) {
  int i;
  if (enemy_count_current+count < enemy_count) {
    for (i=0;i<count;i++) {
      enemies[enemy_count_current] = new Enemy(enemy_count_current+1);
      enemy_count_current++;
    }
  }
  
  int al = 0;

  for (i=0;i<enemy_count_current;i++) {
    if (enemies[i].alive == true) al = 1;
  }
  if (al == 0) gameover = 2;
}

void drawLevel() {
  int i;
  for (i=0;i<enemy_count_current;i++) {
    enemies[i].update();
    stroke(0);
    int ecolor = enemies[i].type*6;
    if (ecolor >= 255) ecolor = 255;
    fill(ecolor,0,0,128);
    if (enemies[i].alive) rect((int)enemies[i].x, (int)enemies[i].y, enemy_size, enemy_size);
    if (player_x+30 >= enemies[i].x && player_x <= enemies[i].x+enemy_size && player_y+45 >= enemies[i].y && player_y <= enemies[i].y+enemy_size && enemies[i].alive) gameover = 1;
    
    for (int j=0;j<bullet_count;j++) {
      if (bullets[j].alive == true) {
        if (bullets[j].x+bullet_size >= enemies[i].x && bullets[j].x <= enemies[i].x+enemy_size && bullets[j].y >= enemies[i].y && bullets[j].y <= enemies[i].y+enemy_size && enemies[i].alive == true) { 
          enemies[i].type-=2;
          bullets[j].alive = false;
          score+=enemies[i].type*112; 
          if (enemies[i].type <= 0) {
            enemies[i].alive = false; 
            spawnEnemies((int)(random(1,5)));
          }
        }
      }
    }
  }
  
}

void drawPlayer() {
  
  if (keyUp == 1 && player_jumping == 0) {
    player_jumping = 1;
  }
  
  if (keyDown == 1 && player_jumping == 1) {
    player_jumping = 2;
  }
  
  if (keyLeft == 1) {
    player_x -= player_speed;
    if (player_speed < 1.6)  player_speed+=0.02;
    player_anim+=player_animspeed;
    if(player_anim >= 7) player_anim = 1;
    if (player_walking == 0) { player_walking = 1; player_anim = 6;}
    
  }
  else if (keyRight == 1) {
    player_x += player_speed;
    if (player_speed < 1.6)  player_speed+=0.02;
    player_anim+=player_animspeed;
    if(player_anim >= 7) player_anim = 1;
    if (player_walking == 0) { player_walking = 1; player_anim = 6;}
  }
  
  if (keyLeft == 2) {
    if (player_speed > 1.3)  {
      player_x -= player_speed;
      player_speed-=0.08;
    }
    else {
      keyLeft = 0;
      player_walking = 0;
    }
  }
  else if (keyRight == 2) {
    if (player_speed > 1.3)  {
      player_x += player_speed;
      player_speed-=0.08;
    }
    else {
      keyRight = 0;
      player_walking = 0;
    }
  }
  
  if (player_jumping == 1) {
    if (player_jump < jump_height) player_jump+=player_speed*2;
    else {
      player_jumping = 2;
    }
  }
  
  if (player_jumping == 2) {
    if (player_jump > 0) player_jump-=player_speed*2;
    else {
      player_jumping = 0;
    }
  }
  
  if (player_x < 0) player_x = 0;
  if (player_x > 640-35) player_x = 640-35;
  
  player_y=player_base-player_jump;

  player_animframe = (int)player_anim;
  if (player_walking == 0) player_animframe = 0;
  if (player_jumping != 0) player_animframe = 1;

  imageMode(CORNERS);
  if (player_animframe == 0) image(player_stand, player_x, player_y);
  else if (player_animframe == 1) image(player_w1, player_x, player_y);
  else if (player_animframe == 2) image(player_w2, player_x, player_y);
  else if (player_animframe == 3) image(player_w3, player_x, player_y);
  else if (player_animframe == 4) image(player_w4, player_x, player_y);
  else if (player_animframe == 5) image(player_w5, player_x, player_y);
  else if (player_animframe == 6) image(player_w6, player_x, player_y);
}

void newBullet(float x, float y) {
  int i = 0;
  int done = 0;
  for (i = 0;i < bullet_count; i++) {
    if (bullets[i].alive == false) {
      bullets[i].x = x;
      bullets[i].y = y;
      bullets[i].speed = bullet_speed;
      bullets[i].alive = true;

      done = 1;
    }
    if (done == 1) break;
  }
}

void drawBullets() {
  if (keyFire == 2) {
    keyFire = 0;
    newBullet(player_x+14, player_y+8);
     laser = minim.loadFile("laser.wav", 1024);

    laser.play();
    soundframes = 50;
  }
  
  if (soundframes > 1) soundframes--;
  if (soundframes <= 0) { laser.close(); }
  
  for (int i = 0; i < bullet_count; i++) {
    bullets[i].update();
    if (bullets[i].alive) {
      stroke(0,255,255);
      noFill();
      line(bullets[i].x, bullets[i].y, bullets[i].x+bullet_size,bullets[i].y);
    }
  }
}

void draw() {
  drawBG();
  drawTexts();
  drawLevel();
  drawPlayer();
  drawBullets();
  noFill();
  stroke(0);
  rect(0,0,width-1,height-1);
  if (gameover == 1) {
    gameover();
  }
  if (gameover == 2) {
    win();
  }
}

void drawTexts() {
  fill(0,0,0,128);
  stroke(0);
  textAlign(CENTER);
  text(texts[ctext], width/2,height/2);
  texttime++;
  if (texttime > 500) {
    texttime = 0;
    ctext = (int)random(1,30);
  }
}

void gameover() {
  fill(255,0,0,128);
  stroke(0);
  rect(0,0,width-1,height-1);
  textAlign(CENTER);
  fill(0,0,0,255);
  stroke(0);
  text("G A M E   O V E R",width/2,(height/2)-18);
  text("...there is no exit.",width/2,(height/2)+24);
  text("score: " + score,width/2,(height/2)+62);
  noLoop();
}

void win() {
  fill(0,255,0,128);
  stroke(0);
  rect(0,0,width-1,height-1);
  textAlign(CENTER);
  fill(0,0,0,255);
  stroke(0);
  text("THE END",width/2,(height/2)-18);
  text("the way out is always present.",width/2,(height/2)+24);
  text("score: " + score,width/2,(height/2)+62);
  
  noLoop();
}

class Bullet {
  float x,y;
  float speed;
  boolean alive;
  
  Bullet(float ex, float ey, boolean ealive) {
    x = ex;
    y = ey;
    alive = ealive;
  }
  
  void update() {
    x+=speed;
    if (x > width) alive = false;
  }
}

class Enemy {
  float x,y;
  float speed;
  int type;
  boolean alive;
  
  Enemy(int etype) {
    x = width+20;
    y = random(6,height-enemy_size-enemy_size);
    speed = etype*0.03;
    type = etype;
    alive = true;
  }  
  void update() {
    x-=speed;
    if (x <= -enemy_size && alive == true) x = width+20;
  }
}
